<?php

/**
 * Integration Demo.
 *
 * @package   Woocommerce My plugin Integration
 * @category Integration
 * @author   Handprint.
 */
include(plugin_dir_path(  __FILE__ ).'config/loadcredential.php');
if ( ! class_exists( 'WC_SaaS_Integration' ) ) :
    class WC_SaaS_Integration extends WC_Integration {
        /**
         * Init and hook in the integration.
         */
        public function __construct() {
          global $woocommerce;
          $this->id                 = 'saas_pledge';
          $this->method_title       = __( 'Hanprint SaaS Pledge','handprint');
          $this->method_description = __( 'Plugin to integrate Handprint SaaS in WooCommerce.','handprint');
          // Load the settings.
          $this->init_form_fields();
          $this->init_settings();
          // Define user set variables.
          
          $this->widget_name          = $this->get_option( 'widget_name' );
          $this->short_description    = $this->get_option( 'short_description' );
          $this->description          = $this->get_option( 'description' );
          // Actions.
          add_action( 'woocommerce_update_options_integration_' .  $this->id, array( $this, 'process_admin_options' ) );
        }

        function admin_options() {
        
        $response_auth = wp_remote_post( APILOGIN, [ 'method' => 'POST', 'timeout' => 45, 'redirection' => 5, 'httpversion' => '1.0', 'blocking' => true, 'headers' => array(), 'body' => ['key' => '', 'password' => ''], 'cookies' => array() ] );
        
            $body_auth = wp_remote_retrieve_body($response_auth);

            $body_auth = isset($body_auth) ? json_decode($body_auth, TRUE) : NULL;
            $token = $body_auth['data']['token'] ?? 1;
            $token_type = $body_auth['data']['token_type'] ?? 1;
            if ( $token && $token_type ){

                wp_enqueue_style( 'handprint-style', APIURL . '/themes/front/default/assets/css/widget-wp.css'); //CSS

                $setting = get_option('woocommerce_saas_pledge_settings');

                $args = wp_parse_args( @$args, ['class' => 'featured', 'data' => ['src' => APIWIDGET . $setting['unique_id'] . '?quanitity=&amount=&currency_code=']] );

                (file_exists(plugin_dir_path( __FILE__ ) . '../../templates/admin/cart/iframe.php')) ? include( plugin_dir_path( __FILE__ ) . '../../templates/admin/cart/iframe.php' ) : ''; //Include Template file
                ?>
                <table class="form-table">
                <?php $this->generate_settings_html(); ?>
                </table> <?php
            }
        }

        /**
         * Initialize integration settings form fields.
         */
        public function init_form_fields() {
        
            $this->form_fields = array(
              'unique_id' => array(
                'title'             => __( 'Serial Key','handprint' ),
                'type'              => 'text',
                'description'       => __( 'Key in your serial key here','handprint' ),
                'desc_tip'          => true,
                'default'           => '',
                'placeholder'       => 'Key in your serial key here'
              ),
              'activate' => array(
                'title'             => __( 'Activate','handprint' ),
                'type'              => 'checkbox',
                'label'             => __( 'Enabled/Disabled','handprint' ),
                'default'           => 1,
                'description'       => __( 'Uncheck to disable in Cart page','handprint' ),
              )
            );
        }
    }
endif;